#include <bits/stdc++.h>

using namespace std;
typedef long long TLL;
 vector<TLL> factorials = {1,1,2,6,24,120,720,5040,40320,362880};

TLL f(int x)
{
  if(x >= 0 && x <= 9)
    return factorials[x];
  else
    return factorials[x % 10] + f(x/10);
}

list<TLL> g(TLL y)
{
  list<TLL> x;
  TLL pos = 9;
  while(y)
  {
    if(y - factorials[pos] >= 0)
    {
      y -= factorials[pos];
      x.push_front(pos);
    }
    else
      pos--;
  }
  return x;
}        
TLL toll(const string& s)
{
  stringstream ss(s);
  TLL x;
  ss >> x;
  return x;

}
void test()
{
   for(TLL i = 1; i <= 1000000000; ++i)
   {
      stringstream ssref;
      stringstream ssst;
      ssref << i;
      auto x = g(f(i));
      for(auto xx : x)
        ssst << xx;
      cout << "ref: " << ssref.str() << ", st: " << ssst.str();
      if(toll(ssref.str()) < toll(ssst.str()))
        cout << "  !!!!!!!!!!!!!";
      if(i < toll(ssst.str()))
        cout << "   ??????????????" << f(toll(ssst.str())) << " " << i;
      cout << endl;
   }
}



int main()
{
  test();
  TLL y;
  cin >> y;  
  auto x = g(y);
  for(auto xx : x)
    cout << xx;
  cout << endl;
  return 0; 
}
